#!/bin/python
# -*- coding: utf-8 -*-

#system imports
import sys
import getopt
import random

#pypkm imports
import pypkm

#my imports
import data

#shorthand arguments definitions, parameters should be the same format as long definitions
a=":p:m:"	#p=pokemon, m=moves
#longhand arguments definitions
la=[
	#"shiny",	#Takes no arguments. Only specify if true. - not implemented yet. Hardly got PID working yet...
	"pokemon=",	#(larvitar/charmander/etc)
	"item=",	#(master ball/HM03/etc)
	"ot=", # (name,id,sid,gender)
	"nickname=",	#(nick)
	"happiness=",	# (#)
	"ability=",	# (guts/drizzle/etc)
	"nature=",	# (timid/adamant/etc)
	"experience=",	# (#)
	"level=",	# (#)	(only one of either exp or lvl needs to be specified)
	"language=",	#2 = english
	"move1=",	# (move[,ppups])
	"move2=",	# (move[,ppups])
	"move3=",	# (move[,ppups])
	"move4=",	# (move[,ppups])
	"moves=",	# (move1,ppups,move2,ppups,move3,ppups,move4,ppups)
	"evs=",	#	(hp,atk,def,spatk,spdef,spd)
	"ivs=", #	(hp,atk,def,spatk,spdef,spd)
	"gender=",	#(male/female/genderless)
	"hometown=",	#game from which the pokemon originates? 20 = pokemon white
	"edate=",	#egg_date (day,month,year-2000)
	"mdate=",	#met_date (day,month,year-2000)
	"egg_location=",	#	(#) (60002 = daycare)
	"met_location=",	#	(#) (e.g. 16 = route 3, this will be implemented in words eventually)
	"met_level=",	#	(#)
	"encounter_type=",	# (#)	(I don't know the types. 0 seems to be for hatched pokes)
	"is_fateful",	#Takes no arguments. Only specify if true.
	"ball="	# (master/poke/quick/timer/etc)
]

pkm=pypkm.new(gen=5)

opts, extraparams = getopt.getopt(sys.argv[1:], a, la)
for o in opts:
	opt = o[0].lstrip("-")
	parms = o[1].split(",") #this is just for readability

	#handle the move,ppups case
	if opt[:4] == "move" and opt[4:5] != "s":
		if len(parms) == 2:
			parms.append(str(data.getMovePPUps(parms[0], int(parms[1]))))
		else:
			parms.append(str(data.getMovePP(parms[0])))
			parms.append("0")

	if opt == "pokemon" or opt == "p":
		pkm.id = data.getPkmNo(parms[0])
		pkm.nickname = parms[0].title()
		if pkm.nickname == "Nidoranm":
			pkm.nickname = u"Nidoran⑭"
		elif pkm.nickname == "Nidoranf":
			pkm.nickname = u"Nidoran⑮"
	elif opt == "move1":
		pkm.moves.move1 = data.getMoveNo(parms[0])
		pkm.moves.move1_ppups = int(parms[1])
		pkm.moves.move1_pp = int(parms[2])
	elif opt == "move2":
		pkm.moves.move2 = data.getMoveNo(parms[0])
		pkm.moves.move2_ppups = int(parms[1])
		pkm.moves.move2_pp = int(parms[2])
	elif opt == "move3":
		pkm.moves.move3 = data.getMoveNo(parms[0])
		pkm.moves.move3_ppups = int(parms[1])
		pkm.moves.move3_pp = int(parms[2])
	elif opt == "move4":
		pkm.moves.move4 = data.getMoveNo(parms[0])
		pkm.moves.move4_ppups = int(parms[1])
		pkm.moves.move4_pp = int(parms[2])
	elif opt == "edate":
		pkm.egg_date.day = int(parms[0])
		pkm.egg_date.month = int(parms[1])
		pkm.egg_date.year = int(parms[2])
	elif opt == "mdate":
		pkm.met_date.day = int(parms[0])
		pkm.met_date.month = int(parms[1])
		pkm.met_date.year = int(parms[2])
	elif opt == "evs":
		pkm.evs.hp = int(parms[0])
		pkm.evs.attack = int(parms[1])
		pkm.evs.defense = int(parms[2])
		pkm.evs.spattack = int(parms[3])
		pkm.evs.spdefense = int(parms[4])
		pkm.evs.speed = int(parms[5])
	elif opt == "ivs":
		pkm.ivs.hp = int(parms[0])
		pkm.ivs.attack = int(parms[1])
		pkm.ivs.defense = int(parms[2])
		pkm.ivs.spattack = int(parms[3])
		pkm.ivs.spdefense = int(parms[4])
		pkm.ivs.speed = int(parms[5])
	elif opt == "ot":
		pkm.ot_name = parms[0]+u"\uFFFF"
		pkm.ot_id = int(parms[1])
		pkm.ot_secret_id = int(parms[2])
		if parms[3] == "male":
			pkm.ot_is_female = False
		else:
			pkm.ot_is_female = True
	elif opt == "item":
		pkm.item = data.getItemNo(parms[0])
	elif opt == "nickname":
		pkm.is_nicknamed = True
		if len(parms[0]) < len(pkm.nickname):
			pkm.nickname = parms[0] + u"\uFFFF" + pkm.nickname[len(parms[0])+1:]
		else:
			pkm.nickname = parms[0]
	elif opt == "gender":
		if parms[0] == "male":
			pkm.is_genderless = False
			pkm.is_female = False
		elif parms[0] == "genderless":
			pkm.is_genderless = True
		else:
			pkm.is_female = True
	elif opt == "ability":
		pkm.ability = data.getAbilityNo(parms[0])
		abilityindex = data.getPkmAbilityIndex(pkm.id, parms[0])
		if abilityindex == 3:
			pkm.has_dwability = True
		else:
			pkm.has_dwability = False
	elif opt == "nature":
		pkm.nature = data.getNatureNo(parms[0])
	elif opt == "experience":
		pkm.experience = int(parms[0])
	elif opt == "level":
		pkm.experience = int(pypkm.sqlite.get_exp(pkm.id, int(parms[0])))
	elif opt == "moves" or opt=="m":
		pkm.moves.move1 = data.getMoveNo(parms[0])
		pkm.moves.move1_ppups = int(parms[1])
		pkm.moves.move1_pp = data.getMovePPUps(parms[0], int(parms[1]))
		pkm.moves.move2 = data.getMoveNo(parms[2])
		pkm.moves.move2_ppups = int(parms[3])
		pkm.moves.move2_pp = data.getMovePPUps(parms[2], int(parms[3]))
		pkm.moves.move3 = data.getMoveNo(parms[4])
		pkm.moves.move3_ppups = int(parms[5])
		pkm.moves.move3_pp = data.getMovePPUps(parms[4], int(parms[5]))
		pkm.moves.move4 = data.getMoveNo(parms[6])
		pkm.moves.move4_ppups = int(parms[7])
		pkm.moves.move4_pp = data.getMovePPUps(parms[6], int(parms[7]))
	elif opt == "is_fateful":
		pkm.is_fateful = True

#***************** PID GENERATION
a = random.randint(0,255)
b = 0
c = random.randint(0,40)
d = random.randint(0,255)

gr=data.getGenderRatio( pkm.id )

if gr == 0:
	#100% male
	ll=0
	ul=30
elif gr == 1:
	#87.5% male
	ll=31
elif gr == 2:
	#75% male
	ll=63
	ul=126
elif gr == 3:
	#50% male
	ll=127
	ul=190
elif gr == 4:
	#25% male
	ll=191
	ul=222
elif gr == 5:
	#12.5% male - no such pokemon exist, but it is a valid category
	ll=223
	ul=253
elif gr == 6:
	#0% male
	ll=254
	ul=254
elif gr == 7:
	#0% male
	ll=255
	ul=255

if pkm.is_female:
	ll=0
else:
	ul=254

for j in range(ll,ul+1):
	if (j%2+1) == abilityindex or abilityindex == 3 or data.getPkmHasSecondAbility(pkm.id) == False:
		if j%25 == pkm.nature:
			b=j
			break

#Combine the four parts of the PID...
pid=int(hex(c)[2:].zfill(2)+hex(d)[2:].zfill(2)+hex(a)[2:].zfill(2)+hex(b)[2:].zfill(2) , 16)
#***************** /PID GENERATION

pkm.pv = pid

sys.stdout.write(pkm.tostring())
